<template>
    <v-card class="elevation-3">
        <Loading :visible="isLoading" />
        <v-card-title>
            Adresse de facturation
        </v-card-title>

        <v-list-item>
            <v-list-item-content>
                <v-form>
                    <v-list-item>
                        <v-list-item-content>
                            <v-row>
                                <v-col cols="6">
                                    <v-text-field id="lastName" v-model="userProfile.lastName" label="Nom*"
                                        :error-messages="lastNameErrors" class="input-field" dense
                                        :disabled="!editMode">
                                    </v-text-field>
                                </v-col>
                                <v-col cols="6">
                                    <v-text-field id="firstName" v-model="userProfile.firstName" label="Prénom*"
                                        :error-messages="firstNameErrors" class="input-field" dense
                                        :disabled="!editMode">
                                    </v-text-field>
                                </v-col>
                            </v-row>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-content>
                            <v-text-field id="street" v-model="userProfile.billingStreet" label="Adresse*"
                                :error-messages="streetErrors" class="input-field" :disabled="!editMode" dense>
                            </v-text-field>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-content>
                            <v-row>
                                <v-col cols="8">
                                    <v-text-field id="city" v-model="userProfile.billingCity" label="Ville*"
                                        :error-messages="cityErrors" class="input-field" :disabled="!editMode" dense>
                                    </v-text-field>
                                </v-col>
                                <v-col cols="4">
                                    <v-text-field id="zc" v-model="userProfile.billingZc" label="Code postal*"
                                        :error-messages="zcErrors" class="input-field" :disabled="!editMode" dense>
                                    </v-text-field>
                                </v-col>
                            </v-row>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-content>
                            <v-text-field id="country" v-model="userProfile.billingCountry" label="Pays*"
                                :error-messages="countryErrors" class="input-field" :disabled="!editMode" dense>
                            </v-text-field>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-content>
                            <v-text-field id="birthday" v-model="userProfile.birthday" label="Date de naissance"
                                placeholder="00/00/0000" :error-messages="dateErrors" class="input-field"
                                v-mask="'##/##/####'" @focus="$event.target.select()" dense :disabled="!editMode">
                            </v-text-field>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-content>
                            <v-text-field id="phone" v-model="userProfile.phone" label="Téléphone*"
                                :error-messages="phoneErrors" class="input-field" @focus="$event.target.select()" dense
                                :disabled="!editMode"></v-text-field>
                        </v-list-item-content>
                    </v-list-item>
                    <v-card-actions>
                        <div v-if="editMode">
                            <v-btn color="secondary" light type="submit" @click="saveInfos">
                                Sauvegarder
                            </v-btn>
                        </div>
                        <div v-else>
                            <v-btn color="secondary" light @click="editProfile">
                                Editer
                            </v-btn>
                        </div>
                    </v-card-actions>
                </v-form>
            </v-list-item-content>
        </v-list-item>
    </v-card>
</template>

<script>
import {
  validationMixin
} from 'vuelidate';
import { mapActions } from 'vuex';
import {
  mapFields
} from 'vuex-map-fields';
import {
  required,
  minLength
} from 'vuelidate/lib/validators';
import moment from 'moment';
import Loading from '../../components/Loading';

export default {
  name: 'UserAdress',
  mixins: [validationMixin],
  components:{
    Loading
  },
  validations: {
    userProfile: {
      lastName: {
        required
      },
      firstName: {
        required
      },
      birthday: {
        minLength: minLength(3),
        isLegalAge: value => {
            if (!value) {   
              return true;
            } else {
              return value && moment(value, 'DD/MM/YYYY').isValid() && moment().diff(moment(value, 'DD/MM/YYYY'), 'years') > 16
            }
        }
      },
      phone: {
        minLength: minLength(5)
      },
      billingStreet: {
        required
      },
      billingCity: {
        required
      },
      billingCountry: {
        required
      },
      billingZc: {
        required
      }
    },
  },
  data: () => ({
    userProfile: {},
    imageAvatar: null,
    imageUrl:'',
    editMode : false,
    errors: []
  }),
  computed: {
    lastNameErrors () {
			const errors = [];
			if (!this.$v.userProfile.lastName.$dirty) return errors
			!this.$v.userProfile.lastName.required && errors.push('Nom requis')
			return errors
		},
		firstNameErrors () {
			const errors = [];
			if (!this.$v.userProfile.firstName.$dirty) return errors
			!this.$v.userProfile.firstName.required && errors.push('Prénom requis')
			return errors
		},
		dateErrors () {
      const errors = [];
      if (!this.$v.userProfile.birthday.$dirty) return errors
      if (!this.userProfile.birthday) return errors
			!this.$v.userProfile.birthday.isLegalAge && errors.push('Vous devez avoir plus de 16 ans')
			return errors
		},
    phoneErrors () {
      const errors = [];
      !this.$v.userProfile.phone.minLength && errors.push('Veuillez mettre un numéro valide')
      return errors
    },
    streetErrors() {
      const errors = [];
      if (!this.$v.userProfile.billingStreet.$dirty) return errors
      !this.$v.userProfile.billingStreet.required && errors.push('Adresse requise')
      return errors
    },
    cityErrors() {
      const errors = [];
      if (!this.$v.userProfile.billingCity.$dirty) return errors
      !this.$v.userProfile.billingCity.required && errors.push('Ville requise')
      return errors
    },
    countryErrors() {
      const errors = [];
      if (!this.$v.userProfile.billingCountry.$dirty) return errors
      !this.$v.userProfile.billingCountry.required && errors.push('Pays requis')
      return errors
    },
    zcErrors() {
      const errors = [];
      if (!this.$v.userProfile.billingZc.$dirty) return errors
      !this.$v.userProfile.billingZc.required && errors.push('Code postal requis')
      return errors
    },
    ...mapFields('user', ['userInfos', 'loggedIn','error', 'isLoading']),
  },
  created() {
    this.getProfile(this.userInfos.id);
    this.userProfile = {
      ...this.userInfos
    };
  },
  methods: {
    saveInfos(event) {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      let user = {};  
      for (const key in this.userProfile) {
        if (this.userProfile[key].length > 0) {
          if (key === 'birthday') {
            user[key] = moment.utc(this.userProfile[key], "DD-MM-YYYY");
          } else {
            user[key] = this.userProfile[key];
          }
        }
      }

      this.updateProfile({
        user: user,
        userId : this.userProfile.id
      });
      this.editMode = !this.editMode;
    },
    editProfile: function (event) {
      event.preventDefault();
      this.editMode = !this.editMode;
    },
     ...mapActions('user', ['getProfile', 'updateProfile'])
  },
  watch: {
    userInfos(newInfos) {
      if(newInfos && newInfos.id) {
        this.userProfile = {
          ...this.userInfos
        };
      }
    }
  }
}
</script>
